/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.ranklist.provider;

import fire.pb.ranklist.provider.BingFengRankData;
import fire.pb.ranklist.provider.ClanFightHistroyRankData;
import fire.pb.ranklist.provider.ClanFightRaceRankData;
import fire.pb.ranklist.provider.ClanProgressRankData;
import fire.pb.ranklist.provider.ClanRankData;
import fire.pb.ranklist.provider.ClanZongHeRankData;
import fire.pb.ranklist.provider.GiveFlowerRankData;
import fire.pb.ranklist.provider.IRankListData;
import fire.pb.ranklist.provider.LevelRankData;
import fire.pb.ranklist.provider.PetScoreRankData;
import fire.pb.ranklist.provider.ProfessionZongheRankData;
import fire.pb.ranklist.provider.PvP5RankData;
import fire.pb.ranklist.provider.RankData;
import fire.pb.ranklist.provider.ReceFlowerRankData;
import fire.pb.ranklist.provider.RedPackRankData;
import fire.pb.ranklist.provider.RoleRankData;
import fire.pb.ranklist.provider.RoleZongheRankData;

public class RankDataFactory {
    private static RankDataFactory _instance;

    private RankDataFactory() {
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static RankDataFactory getInstance() {
        Class<RankData> clazz = RankData.class;
        synchronized (RankData.class) {
            if (null == _instance) {
                _instance = new RankDataFactory();
            }
            // ** MonitorExit[var0] (shouldn't be in output)
            return _instance;
        }
    }

    public IRankListData createRankProvider(int rankType, long requestRoleid) {
        RankData provider = null;
        switch (rankType) {
            case 1: {
                provider = new LevelRankData(rankType, requestRoleid);
                break;
            }
            case 9: {
                provider = new PetScoreRankData(rankType, requestRoleid);
                break;
            }
            case 31: {
                provider = new ClanRankData(rankType, requestRoleid);
                break;
            }
            case 32: {
                provider = new RoleZongheRankData(rankType, requestRoleid);
                break;
            }
            case 43: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 44: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 45: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 46: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 47: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 48: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 60: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 61: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 62: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 63: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 64: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 65: {
                provider = new ProfessionZongheRankData(rankType, requestRoleid);
                break;
            }
            case 38: {
                provider = new RoleRankData(rankType, requestRoleid);
                break;
            }
            case 49: {
                provider = new ClanRankData(rankType, requestRoleid);
                break;
            }
            case 50: {
                provider = new ClanZongHeRankData(rankType, requestRoleid);
                break;
            }
            case 21: 
            case 22: 
            case 23: 
            case 24: {
                provider = new BingFengRankData(rankType, requestRoleid);
                break;
            }
            case 70: {
                provider = new ClanProgressRankData(rankType, requestRoleid);
                break;
            }
            case 81: 
            case 82: 
            case 83: 
            case 84: 
            case 85: 
            case 86: 
            case 87: 
            case 88: 
            case 89: 
            case 90: 
            case 91: 
            case 92: {
                provider = new PvP5RankData(rankType, requestRoleid);
                break;
            }
            case 101: 
            case 102: {
                provider = new RedPackRankData(rankType, requestRoleid);
                break;
            }
            case 111: {
                provider = new ReceFlowerRankData(rankType, requestRoleid);
                break;
            }
            case 112: {
                provider = new GiveFlowerRankData(rankType, requestRoleid);
                break;
            }
            case 120: 
            case 121: 
            case 122: {
                provider = new ClanFightRaceRankData(rankType, requestRoleid);
                break;
            }
            case 123: {
                provider = new ClanFightHistroyRankData(rankType, requestRoleid);
            }
        }
        return provider;
    }
}

